%
% %%% GENERATOR: %%%
% Autor: Wiebke Petersen
% Datum: 26.01.2016
%

:- module(app_generator, [generate/3, generate_all/3, generate_all/4]).


% generate/3
% generate(+STR:category, +INT:length, +STR:{none,tree,dot}).
generate(C, N, Out):- 
    generate_empty_list(N, S), 
    parse(C, S, Out).


% generate_empty_list/2
% generate_empty_list(+INT:length,-LIST).
generate_empty_list(0,[]).

generate_empty_list(N, [_|L]):-
    N > 0,
    N1 is N - 1,
    generate_empty_list(N1, L).


% generate_all/3
% generate_all(+STR:category, +INT:length, +STR:{none,tree,dot}).
generate_all(C, N, Out):-
    generate(C, N, Out),
    fail.

generate_all(_, _, _).


% generate_all/4
% generate_all(+STR:category, +INT:min-length, +INT:max-length, +STR:{none,tree,dot}).
generate_all(C, Max, Max, Out):- generate_all(C, Max, Out).

generate_all(C, Min, Max, Out):-
    Min < Max, Next is Min + 1,
    generate_all(C, Min, Out),
    generate_all(C, Next, Max, Out).