%
% %%% HELPER: %%%
% Autor: Wiebke Petersen
% Datum: 26.01.2016
%

:- module(app_helper, [empty_output/0, concat/2]).
:- dynamic(file/1).


% empty_output/0
empty_output:-
    empty_output(1),                                            % leert den Ordner output/output
    !,                                         
    open('output/outtrees.txt', write, FS1),                    % leert outtrees.txt
    close(FS1),        
    open('output/outstrings.txt', write, FS2),                  % leert outstrings.txt
    close(FS2),      
    retractall(file(_)),
    assert(file(1)).


% empty_output/1
% empty_output(+INT:id)
empty_output(N):-
    concat(['output/output', N, '.jpg'], FileJPG),
    concat(['output/output', N, '.dot'], FileDOT),
    exists_file(FileJPG),
    delete_file(FileJPG),
    delete_file(FileDOT),
    N1 is N + 1,
    empty_output(N1).

empty_output(_).


% concat/2
% concat(+list:input, -STR:output).
% concat(-list:output, +STR:input).
concat(L, Name):-
    concat(L, [], Name).

concat([], Acc, Name):- name(Name, Acc).

concat([H|T], Acc, Name):-
    name(H, L),
    append(Acc, L, Lnew),
    concat(T, Lnew, Name).


