%
% %%% LEXICON: %%%
% Autor: Simon Münker
% Datum: 08.01.2018
%


% det(lex, (kas, num, gen, def))
det(det(der), (nom, sg, masc, def)) --> [der].
det(det(den), (akk, sg, masc, def)) --> [den].
det(det(dem), (dat, sg, masc, def)) --> [dem].

det(det(die), (nom, sg, fem, def)) --> [die].
det(det(die), (akk, sg, fem, def)) --> [die].
det(det(die), (dat, sg, fem, def)) --> [der].

det(det(das), (nom, sg, neu, def)) --> [das].
det(det(das), (akk, sg, neu, def)) --> [das].
det(det(das), (dat, sg, neu, def)) --> [dem].

det(det(die), (nom, pl, _, def)) --> [die].
det(det(die), (akk, pl, _, def)) --> [die].
det(det(der), (dat, pl, _, def)) --> [den].


det(det(ein), (nom, sg, masc, ind)) --> [ein].
det(det(den), (akk, sg, masc, ind)) --> [einen].
det(det(dem), (dat, sg, masc, ind)) --> [einem].

det(det(die), (nom, sg, fem, def)) --> [eine].
det(det(die), (akk, sg, fem, def)) --> [eine].
det(det(die), (dat, sg, fem, def)) --> [einer].

det(det(das), (nom, sg, neu, def)) --> [ein].
det(det(das), (akk, sg, neu, def)) --> [ein].
det(det(das), (dat, sg, neu, def)) --> [einem].


% n(lex, (kas, num, gen))
n(n(maus), (_, sg, fem, _)) --> [maus].
n(n(maeuse), (nom, pl, _, _)) --> [maeuse].
n(n(maeuse), (akk, pl, _, _)) --> [maeuse].
n(n(maeusen), (dat, pl, _, _)) --> [maeusen].

n(n(katze), (_, sg, fem, _)) --> [katze].
n(n(katzen), (_, pl, _, _)) --> [katzen].

n(n(hund), (_, sg, masc, _)) --> [hund].
n(n(hunde), (nom, pl, masc, _)) --> [hunde].
n(n(hunde), (akk, pl, masc, _)) --> [hunde].
n(n(hunden), (dat, pl, masc, _)) --> [hunden].

n(n(pferd), (_, sg, neu, _)) --> [pferd].
n(n(pferde), (nom, pl, neu, _)) --> [pferde].
n(n(pferde), (akk, pl, neu, _)) --> [pferde].
n(n(pferden), (dat, pl, neu, _)) --> [pferden].


% ne(lex, (kas, num, gen))
pn(pn(simon), (_, sg, masc, _)) --> [simon].
pn(pn(mari), (_, sg, fem, _)) --> [mari].
pn(pn(gerrit), (_, sg, masc, _)) --> [gerrit].


% v(lex, (num, val=1))
v(v(jagt), (sg, 1)) --> [jagt].
v(v(jagen), (pl, 1)) --> [jagen].


% v(lex, (num, val=2, kas(2)))
v(v(jagt), (sg, 2, akk)) --> [jagt].
v(v(jagen), (pl, 2, akk)) --> [jagen].

v(v(hilft), (sg, 2, dat)) --> [hilft].
v(v(helfen), (pl, 2, dat)) --> [helfen].


% v(lex, (num, val=3, kas(2), kas(3)))
v(v(gibt), (sg, 3, dat, akk)) --> [gibt].
v(v(geben), (pl, 3, dat, akk)) --> [geben].


% adj(lex, (kas, num, gen, def))
adj(adj(mutige), (nom, sg, _, def)) --> [mutige].
adj(adj(mutiger), (nom, sg, masc, ind)) --> [mutiger].
adj(adj(mutiges), (nom, sg, fem, ind)) --> [mutiges].
adj(adj(mutige), (nom, sg, neu, ind)) --> [mutige].

adj(adj(mutigen), (nom, pl, _, def)) --> [mutigen].