%
% %%% PARSER: %%%
% Autor: Wiebke Petersen
% Datum: 26.01.2016
%

:- module(app_parser, [parse/3]).
:- dynamic(file/1).
:- retractall(file(_)).
:- assert(file(1)).

% parse(output:string)/3
% parse(+STR:category, +LIST:content, none).
parse(C, S, none):-
    Term =.. [C, _, S, []],
    Term,
    open('output/outstrings.txt', append, FS),
    pprint_list(S, FS),
    close(FS).


% parse(output:tree)/3
% parse(+STR:category, +LIST:content, -STR:tree).
parse(C, S, tree):-
    Term =.. [C, T, S, []],
    Term,
    open('output/outtrees.txt', append, FS),
    pprint_list(S, FS),
    pprint_tree(T, FS),
    close(FS).


% parse(output:dot)/3
% parse(+STR:category, +LIST:content, dot).
parse(C, S, dot):-
    Term =.. [C, T, S, []],
    Term,
    retract(file(N)),
    N1 is N+1,
    assert(file(N1)),
    concat(['output/output', N, '.dot'], Output),
    open(Output, write, FS),
    pprint_dot(T, FS),
    close(FS),
    dotjpeg(N).


% dotjpeg/1
% dotjpeg(+INT:id).
dotjpeg(N) :-
  concat(['dot output/output', N, '.dot -Tjpg -o output/output', N, '.jpg'], Call),
  shell(Call).