%
% %%% RULESET: %%%
% Autor: Simon Münker
% Datum: 08.01.2018
%


% %%% BUILDING S: %%%

% s -> NP VP
s(s(NP,VP)) --> np(NP, (nom, NUM, _)), vp(VP, (NUM, _, _)).


% %%% BUILDING NP: %%%

% NP -> PN
np(np(PN), (KAS, NUM, GEN)) --> pn(PN, (KAS, NUM, GEN)).

% NP(pl) -> N'
np(np(N), (KAS, pl, GEN)) --> nbar(nbar(N), (KAS, pl, GEN, _)).

% NP -> DET N'
np(np(DET, NBAR), (KAS, NUM, GEN)) --> det(DET, (KAS, NUM, GEN, DEF)), nbar(NBAR, (KAS, NUM, GEN, DEF)).

% N' -> ADJ N'
nbar(nbar(ADJ, NBAR), (KAS, NUM, GEN, DEF)) --> adj(ADJ, (KAS, NUM, GEN, DEF)), nbar(NBAR, (KAS, NUM, GEN, DEF)).

% N -> N
nbar(nbar(N), (KAS, NUM, GEN, DEF)) --> n(N, (KAS, NUM, GEN, DEF)).


% %%% BUILDING VP: %%%

% VP -> V
vp(vp(V), (NUM, 1, _, _)) --> v(V, (NUM, 1)).

% VP -> V NP
vp(vp(V, NP), (NUM, 2, akk, _)) --> v(V, (NUM, 2, akk)), np(NP, (akk, _, _)).
vp(vp(V, NP), (NUM, 2, dat, _)) --> v(V, (NUM, 2, dat)), np(NP, (dat, _, _)).

% VP -> V NP NP
vp(vp(V, NP1, NP2), (NUM, 3, dat, akk)) --> v(V, (NUM, 3, dat, akk)), np(NP1, (dat, _, _)), np(NP2, (akk, _, _)).
