%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                               %
% Schreiben ein Prädikat travelRoute/3, das die Reiseroute zu zwei Orten        %
% berechnet und diese in eine Liste packt (es genügt, wenn nur eine Route       %
% berechnet wird und Prolog in eine Endlosschleife läuft, wenn es keine         %
% Route gibt, oder nachweiteren Routen gefragt wird).                           %
%                                                                               %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


travelRoute(Start,Ziel,Route):-                                                 % Die Route zwischen Start und Ziel wird 
     travelRoute1(Start,[Ziel],Route).                                          % in der Liste Ziel gespeichert

travelRoute1(Start,[TeilZiel|TeilRoute],[Start,TeilZiel|TeilRoute]):-           % der Startpunkt wird als Head der Liste gespeichert
     directTrain(Start,TeilZiel),!.                                             % und nach der Verbindung zwischen Start und TeilZiel wird 
                                                                                % ein Cut durchgeführt
     
travelRoute1(Start,[TeilZiel|TeilRoute],Route):-                                % Wenn noch Elemente in der Route vorhanden sind,
     directTrain(Transfer,TeilZiel),                                            % muss es eine direkte Verbindung zwischen dem Transfer und Teilziel geben,
     not(member(Transfer,TeilRoute)),                                           % der Transfer darf kein Teil der Teilroute sein und
     travelRoute1(Start,[Transfer,TeilZiel|TeilRoute],Route).                   % die Abfrage wird rekursiv aufgerufen.


travelRouteNew(Start,Ziel,[Start|Route]):-                                      % 
     retractall(passed(_)),                                                     %
     assert(passed(Start)),                                                     % man gibt den Startort weiter und
     travelRoute2(Start,Ziel,Route).                                            % beginnt einen rekursiven Aufruf

travelRoute2(Start,Ziel,[Ziel]):-                                               % Sind alle Elemente in der Liste Ziel,
     directTrain(Start,Ziel),                                                   % gibt es eine direkte Verbindung zwischen Start und Ziel,
     assert(passed(Start)),!.                                                   % nachdem man Start verlassen hat, erfolgt ein Cut

travelRoute2(Start,Ziel,[TeilZiel|Route]):-                                     % Wenn noch Elemente gelesen werden
     directTrain(Start,TeilZiel),                                               % muss es eine direkte Verbindung zwischen Start und TeilZiel geben,
     not(passed(TeilZiel)),                                                     % sodass man noch nicht am TeilZiel war und
     assert(passed(TeilZiel)),                                                  % dieses nun einliest
     travelRoute2(TeilZiel,Ziel,Route).                                         % und anschließend weiter rekursiv vorgeht


prepare:-                                                                       
     retractall(directTrain(_,_)),                                              % alle direkten Verbindungen werden aufgerufen
     consult(travelRoute_connections),                                          % und mit dem Lexikon verglichen
     preparetrain.                                                              


preparetrain:-                                                                  
     directTrain(A,B),                                                          % 
     assert(directTrain(B,A)),                                                  %
     fail.                                                                      %

preparetrain.                                                                   %


:- prepare.                                                                     % 
